﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using kr.go.ads.compare;

namespace kr.go.ads.client
{
    public class ReceiveDatas
    {
        //--- request information ------//
        private String reqCntc;
        private String reqAppKey;
        private String reqDateGb;
        private String reqRetryIn;
        private String reqDt;
        private String reqDtTo;
        private int result;

	    //--- receive information ------//
        private int resTotalCnt;	/* 응답받은 전체 데이터 건수 */
        private int resNormalCnt;	/* 응답받은 변동자료 데이터 건수 */
        private int resRetryCnt;	/* 응답받은 반재영 데이터 건수 */
        private String resCode = "E1999";		/* 응답코드 */

        private List<ReceiveData> list;

        public ReceiveDatas()
        {
            if (list == null)
            {
                list = new List<ReceiveData>();
            }
        }

        public String ReqCntc
        {
            get { return reqCntc; }
            set { reqCntc = value; }
        }

        public String ReqAppKey
        {
            get { return reqAppKey; }
            set { reqAppKey = value; }
        }

        public String ReqDateGb
        {
            get { return reqDateGb; }
            set { reqDateGb = value; }
        }

        public String ReqRetryIn
        {
            get { return reqRetryIn; }
            set { reqRetryIn = value; }
        }

        public String ReqDt
        {
            get { return reqDt; }
            set { reqDt = value; }
        }

        public String ReqDtTo
        {
            get { return reqDtTo; }
            set { reqDtTo = value; }
        }

        public int Result
        {
            get { return result; }
            set { result = value; }
        }

        public int ResTotalCnt
        {
            get { return resTotalCnt; }
            set { resTotalCnt = value; }
        }

        public int ResNormalCnt
        {
            get { return resNormalCnt; }
            set { resNormalCnt = value; }
        }

        public int ResRetryCnt
        {
            get { return resRetryCnt; }
            set { resRetryCnt = value; }
        }

        public String ResCode
        {
            get { return resCode; }
            set { resCode = value; }
        }

        public void Add(ReceiveData receiveData)
        {
            list.Add(receiveData);
        }

        public List<ReceiveData> getReceiveDatas()
        {
            return list;
        }

        public String getResMsg()
        {
            String msg = "";
            if ("P0000".Equals(this.resCode))
            {
                msg = "정상 반영";
            }
            else if ("P1000".Equals(this.resCode))
            {
                msg = "최신 상태입니다. 대상 파일이 없습니다.";
            }
            else if ("E0001".Equals(this.resCode))
            {
                msg = "승인키를 확인하세요.(승인키 정보 오류)";
            }
            else if ("E0002".Equals(this.resCode))
            {
                msg = "승인되지 않은 사이트입니다.";
            }
            else if ("E0003".Equals(this.resCode))
            {
                msg = "정상적인 경로로 접속하시기 바랍니다.";
            }
            else if ("E0004".Equals(this.resCode))
            {
                msg = "업데이트서버 신청이 필요합니다.";
            }
            else if ("E0005".Equals(this.resCode))
            {
                msg = "서버의 응답이 없습니다. 잠시후 시도해 주세요.";
            }
            else if ("E1001".Equals(this.resCode))
            {
                msg = "해당 파일이 없습니다.";
            }
            else if ("E1002".Equals(this.resCode))
            {
                msg = "요청자료 구분코드가 필요합니다.";
            }
            else if ("E1003".Equals(this.resCode))
            {
                msg = "승인키가 필요합니다.(승인키 입력누락)";
            }
            else if ("E1004".Equals(this.resCode))
            {
                msg = "요청기간이 최대 기일을 초과 하였습니다.(MAX 10일)";
            }
            else if ("E1005".Equals(this.resCode))
            {
                msg = "시스템 에러 : 응답메시지 생성 오류";
            }
            else if ("E1006".Equals(this.resCode))
            {
                msg = "월, 일 변동구분 값을 확인하세요.";
            }
            else if ("E1007".Equals(this.resCode))
            {
                msg = "요청일자는 YYYYMMDD 형식입니다.";
            }
            else if ("E1008".Equals(this.resCode))
            {
                msg = "제공할 데이터가 없습니다. 제공할 파라미터가 등록되어있지 않습니다.";
            }
            else if ("P1999".Equals(this.resCode))
            {
                msg = "관리자에게 문의하세요.(1588-0061)";
            }
            else
            {
                msg = "관리자에게 문의하세요.(1588-0061)";
            }

            return msg;
        }

        /**
         *	@param order 다운로드 받은 파일을 정렬 방법
         *		   ADSUtils.MAKE_ASC : 파일 생성일 기준 오름차순 정렬
         *		   ADSUtils.FILE_ASC : 파일데이터의 기준일자 오름차순 정렬
         *		   ADSUtils.UPDATE_ASC : 반영시 순서 기준 오름차순 정렬
         *
         *	@return ArrayList order순서에 의해서 정렬된 다운로드 데이터 정보 list
         **/
        public List<ReceiveData> getReceiveDatas(int order)
        {
            IComparer<ReceiveData> comparer = null;

            if (order == ADSUtils.MAKE_ASC)
            {
                comparer = new MakeAscCompare();
            }
            else if (order == ADSUtils.FILE_ASC)
            {
                comparer =  new FileAscCompare();
            }
            else if (order == ADSUtils.UPDATE_ASC)
            {
                comparer = new UpdateAscCompare();
            }

            list.Sort(comparer);
            return list;
        }
    }
}
